# Request-Processing

This project uses Quarkus, the Supersonic Subatomic Java Framework.

If you want to learn more about Quarkus, please visit its website: https://quarkus.io/ .

## Prerequisites

* Java17 installed with JAVA_HOME configured appropriately
* Optionally the [Quarkus CLI](https://quarkus.io/guides/cli-tooling) if you want to use it

## Running the application in dev mode

You can run your application in dev mode that enables live coding using:
```shell script
./mvnw compile quarkus:dev
```

> **_NOTE:_**  Quarkus now ships with a Dev UI, which is available in dev mode only at http://localhost:8080/q/dev/.


## Running Locally via Docker Compose

> **_NOTE_** The custom images for the infrastructure can be built with the following scripts:
> ```bash
> deploy/docker/build_keycloak.sh
> deploy/docker/build_rabbitmq.sh
> ```


| Description | Docker Compose Run Command                                               |
| ----------- | ------------------------------------------------------------------------ |
| JVM Java 17 | `docker-compose -f deploy/docker-compose/java17.yml up --remove-orphans` |


## Packaging and running the application

The application can be packaged using:
```shell script
./mvnw package
```
It produces the `quarkus-run.jar` file in the `target/quarkus-app/` directory.
Be aware that it’s not an _über-jar_ as the dependencies are copied into the `target/quarkus-app/lib/` directory.

The application is now runnable using `java -jar target/quarkus-app/quarkus-run.jar`.

If you want to build an _über-jar_, execute the following command:
```shell script
./mvnw package -Dquarkus.package.type=uber-jar
```

The application, packaged as an _über-jar_, is now runnable using `java -jar target/*-runner.jar`.

## Creating an image

You can create a Docker image using:
```shell script
./mvnw package -Dquarkus.container-image.build=true
```

Optionally the `build-container-images.sh` script can be used (see the `scripts` folder).

## Creating a native executable

You can create a native executable using: 
```shell script
./mvnw package -Pnative
```

Or, if you don't have GraalVM installed, you can run the native executable build in a container using: 
```shell script
./mvnw package -Pnative -Dquarkus.native.container-build=true
```

You can then execute your native executable with: `./target/request-processing-1.0.0-SNAPSHOT-runner`

If you want to learn more about building native executables, please consult https://quarkus.io/guides/maven-tooling.
